; simple test-code for Counter-module

$include (mod51)	;SFR-defines for 8031

$include (cnt.def)	;own defines


;##################### MAIN Program #######################################

cseg at 0
    USING 0     	;Bank 0

org 0000h
    jmp main_start	;start-vector

org 0003h               ;extInt0
    ljmp Ext0Int

org 000bh               ;timer0
    ljmp Int_T0

org 0013h               ;extInt1
reti

org 001Bh               ;timer1
reti

org 0023h               ;RS232
reti

;**************************************************************************

main_start:
	mov SP,  #Stack_First
	mov DPTR,#0
	mov acc, #0
	mov b,	 #0
	mov PSW, #0
	mov PCON,#0
	mov SCON,#0
	mov TCON,#0
	mov TMOD,#0
	mov IE,  #0
	mov IP,  #0


	clr blick_cursor	;no cursor on LCD
	call lcd_init

	call Init_ExtInt0

	mov Timer10ms,#Cnt_T10ms
	call init_T0

	mov DPTR,#LCD_TEXT	;LCD-text
	clr step_walk		;LCD-output with no delay
	call lcdstring		;put const-string to LCD

	mov P1,#00Fh
	mov P3,#0FFh

	clr RI

	mov a,#255
	mov b,#HCT138_Y1	;write to HCT574
	call out_io

	setb EA
	call StartCounting

;################## Main - L O O P ########################

MainLoop:
	jnb ready, MainLoop	;wait for T0-ret
	clr ready
	mov a,#0
	call setcursor
	call ReadCounter
	call WriteCounter
	cpl  Led2		;toggle LED2		
	call StartCounting
        sjmp MainLoop           ;nothings to do


;-----------------------------------------------------------------
ReadCounter:
	setb Clk		;count to Latch-574
	nop
	nop
	clr  Clk
	mov b,#HCT138_Y6	;read from HCT574
	call in_io
	mov BCD_Count,a
	mov b,#HCT138_Y7	;read from HCT574
	call in_io
	mov BCD_Count+1,a
	ret

;-----------------------------------------------------------------
WriteCounter:
	;convert counter to ASCII
	mov a,BCD_Count+4
	swap a
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer,a
	mov a,BCD_Count+4
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+1,a

	mov a,BCD_Count+3
	swap a
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+2,a
	mov a,BCD_Count+3
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+3,a

	mov a,BCD_Count+2
	swap a
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+4,a
	mov a,BCD_Count+2
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+5,a

	mov a,BCD_Count+1
	swap a
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+6,a
	mov a,BCD_Count+1
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+7,a

	mov a,BCD_Count
	swap a
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+8,a
	mov a,BCD_Count
	anl a,#0Fh
	add a,#30h
	mov lcd_buffer+9,a
	mov lcd_buffer+10,#' '
	mov lcd_buffer+11,#'H'
	mov lcd_buffer+12,#'z'
	mov lcd_buffer+13,#ENDE		;sign End for LCD

	call WriteLCD_Array		;write lcd_buffer to LCD
	ret


;****************************************************************
StartCounting:
	clr Tor
	setb Res		;clr HC4518
	mov BCD_Count+2,#0	;SW-BCD-Counter
	mov BCD_Count+3,#0
	mov BCD_Count+4,#0
	mov TL0,#TL0Value	;restart Timer
	mov TH0,#TH0Value 

	setb Tor		;open Gate
	clr Res			;enable counting on HC4518
	setb EX0		;enable Int0
	setb TR0		;enable T0
	ret

;-----------------------------------------------------------------

$include (cnt.inc)		;own hw-functions

;-----------------------------------------------------------------
init_T0:
	clr TR0			;stop T0
	anl TMOD,#11110000b     ;16 bit Timer0 (gate C/T MODE)
	orl TMOD,#00000001b     ;Gate0 (01-16-bit 10-8bit reload)
	mov TL0,#TL0Value
	mov TH0,#TH0Value 

	clr TF0
	setb PT0		;higher priority
		;setb TR0	;set in StartCounting
	setb ET0

	clr ready		;return-bit isr-T0

	ret

;****************************************************************
Init_ExtInt0:

	setb IT0		;init: counting of CLK-edges
	clr  IE0
	setb PX0
		;setb EX0	;set in StartCounting
	setb F0

	ret

;################ Interrupts ###################

Int_T0:
	push PSW
	djnz Timer10ms,Int_T0_Ret
	mov Timer10ms,#Cnt_T10ms
	clr Tor			;close Gate
	setb ready		;Ready-Info to Main()
	clr TR0			;stop T0
	nop
	nop
	nop
	nop
	clr EX0			;stop Int0
	sjmp T0_Ret
Int_T0_Ret:
	clr TR0			;stop T0
	mov TL0,#TL0Value	;reinit T0
	mov TH0,#TH0Value 
	setb TR0		;run T0
T0_Ret:
	pop PSW
	reti


Ext0Int:
	push PSW
	push acc

	inc BCD_Count+2		;bcd-counter
	mov a, BCD_Count+2
	clr c
	clr ac
	DA a
	mov BCD_Count+2,a		
	jnc Ext0IntRet		;next +1  ?
	inc BCD_Count+3
	mov a,BCD_Count+3
	clr c
	clr ac
	DA a
	mov BCD_Count+3,a
	jnc Ext0IntRet		;next +1  ?
	inc BCD_Count+4
	mov a,BCD_Count+4
	clr c
	clr ac
	DA a
	mov BCD_Count+4,a
Ext0IntRet:
	pop acc
	pop PSW
        reti


LCD_EMPTY:     DB '                ',ENDE
LCD_TEXT:      DB '** counter **   ',ENDE

end
